
# modulo os
# os.getcwd()
# os.listdir(path)
# os.path.isfile, os.path.isdir()

import os

def conta_f(pathDir=os.getcwd()):
    '''conta i file presenti all'interno di una determinata directory'''
    count=0
    for x in os.listdir(pathDir):
        if x[0]=='.': 
            continue
        path1=pathDir + '/' + x
        if os.path.isfile(path1):
            count+=1
    return count

########################################################
    
def conta_fR(pathDir=os.getcwd()):
    '''conta i file presenti nella directory 
    e in tutte le sue sottodirectory'''
    count=0
    for x in os.listdir(pathDir):
        if x[0]=='.': 
            continue
        path1=pathDir + '/' + x
        if os.path.isfile(path1):
            count+=1
        else:
            count+=conta_fR(path1)
    return count

####################################################

def lista_k(k,pathDir=os.getcwd()):
    '''Restituisce la lista coi percorsi  alle sottocartelle 
    che contengono esattamente k file'''
    lista=[]
    count=0
    for x in os.listdir(pathDir):
        if x[0] == '.':
            continue
        path1=pathDir + '/'+x 
        if  os.path.isfile(path1): 
            count += 1
        else:
            lista+=lista_k(k,path1)
    if count == k : lista += [pathDir]
    return lista


################################################################## 
    
class Nodo:
    def __init__(self,valore):
        self.v=valore
        self.figli=[]
         
def creaT(path=os.getcwd()):
    nodo=Nodo(path)
    if os.path.isdir(path):
        for x in os.listdir(path):
            if x[0]=='.':continue
            path1=path + '/' + x
            a=creaT(path1)
            nodo.figli.append(a)
    return nodo
    
# >>> r=creaT('Informatica')
# >>> type(r)
#  __main__.Nodo
# r.v
# '/Users/angelo/Desktop/lezioni2019/l15' 
    
##################################################
    
def conta(r):
    '''restituisce il numero di nodi nell'albero radicato in r'''
    tot=1
    for x in r.figli:
        tot+=conta(x)
    return tot

#>>> conta(4)
# 41
    
def foglie(r):
    '''restituisce il numero di fglie nell'albero radicato in r'''
    if r.figli==[]: 
        return 1
    tot=0
    for x in r.figli:
        tot+= foglie(x)
    return tot

# >>> foglie(r)
# 28
    
def altezza(r):
    '''restituisce l'altezza dell'albero radicato in r'''
    if r.figli==[]: return 0
    alt=0
    for x in r.figli:
        alt=max(alt,altezza(x))
    return alt +1
    
# >>> altezza(r)
# 6
    
  
def stampa(r,liv=0):
    '''stampa l'albero indentando per livello'''
    a=r.v
    #a=os.path.basename(r.v)  #e' meglio nel caso in cui r.v siano indirizzi di memoria
    print('|   '*liv,a)
    for x in r.figli:
        stampa(x,liv+1)
        
